diff --git a/src/copy_paste.h b/src/copy_paste.h
new file mode 100644
--- /dev/null
+++ b/src/copy_paste.h
@@ -0,0 +1,113 @@
+/* $Id: command_queue.h 4998 2006-05-30 16:13:41Z Frostregen $ */
+
+#ifndef COPY_PASTE_H
+#define COPY_PASTE_H
+
+#include "map_type.h"
+#include "command_type.h"
+#include "signal_type.h"
+#include "track_type.h"
+#include "slope_type.h"
+#include "road_map.h"
+#include "saveload/saveload.h"
+
+class CopyPaste {
+public:
+	bool  m_copy_with_rail;          ///< If rail should be copied
+	bool  m_copy_with_road;          ///< If road should be copied
+	bool  m_copy_with_other;         ///< If stuff owned by other players should be copied
+
+	uint8 m_paste_vacant_terrain;    ///< If empty terrain should be recreated. 0 = no terraform, 1 = terraform only needed, 2 = terraform all terrain
+	bool  m_convert_rail;            ///< If rails should be converted to currently selected railtype
+	bool  m_clear_before_build;      ///< If terrain should be bulldozed before we try to paste it
+	bool  m_toggle_signal_direction; ///< If signal direction should be toggled when pasting
+
+private:
+	uint32   m_width;
+	uint32   m_height;
+        StringID error_str;
+	char     *error_msg;
+
+	CommandCost m_costs; ///< Stores the costs needed for template paste - estimate
+
+	/** Storage space for copied area 
+	 * TODO: Convert to struct (saveload...)
+	 */
+	int8   *m_heightmap;      ///<  | Move terrain needed into this...
+	uint8  *m_terrain_needed; ///<  2Bit needed
+	uint8  *m_tiletype;       ///<  8Bit needed
+	uint8  *m_railroad;       ///<  8Bit needed
+	uint16 *m_signals;        ///< 15Bit needed
+	//TODO: uint8 *m_station;
+
+public:
+	enum CopyPasteTileType {
+		CP_TILE_CLEAR,
+		CP_TILE_RAIL,
+		CP_TILE_ROAD,
+		CP_TILE_TUNNELBRIDGE,
+		CP_TILE_STATION,
+	};
+	explicit CopyPaste();
+	~CopyPaste();
+
+	SaveOrLoadResult SaveLoadTemplate(const char *filename, int mode);
+	const char *GetErrorString();
+	bool IsSomethingCopied(); ///< Returns if something is in our copy buffer.
+	void AllocateMapArray(uint32 max_tiles); ///< allocate a map array
+	void ClearCopyArrays();   ///< Clears content of copy buffers for current width/height, but does NOT reset width/height.
+
+	void CopyArea(TileIndex end, TileIndex start); ///< Copies given area into copy buffer
+	void PasteArea(TileIndex tile);                ///< Paste copied content onto map, taking care of multiplayer/singleplayer environment.
+
+	void RotateSelectionCCW();
+	void RotateSelectionCW();
+	void MirrorSelectionHorizontal();
+	void MirrorSelectionVertical();
+	uint GetHeight(uint baseh, uint index);
+	Slope GetSlope(uint index);
+	CopyPasteTileType GetCPTileType(uint index);
+	uint GetCPMinorTileType(uint index);
+	TrackBits GetCPTrackBits(uint index);
+
+	FORCEINLINE uint32 GetWidth()  { return m_width;  };	///< Used by the GUI
+	FORCEINLINE uint32 GetHeight() { return m_height; };
+
+private:
+	void SetError(StringID message, StringID extra = INVALID_STRING_ID);
+
+	void internal_PasteArea(TileIndex tile); ///< internal PasteArea method
+
+	void CP_DoCommand(TileIndex tile, uint32 p1, uint32 p2, CommandCallback *callback, uint32 cmd); ///< Special DoCommand for CopyPaste
+
+	void CP_RaiseLowerLand  (TileIndex tile, int mode);
+	void CP_PlaceRail       (TileIndex tile, int cmd, uint32 railtype);
+	void CP_PlaceSignals    (TileIndex tile, Track track, SignalType type, uint direction, bool semaphore);
+	void CP_PlaceRoad       (TileIndex tile, uint8 road_bits);
+	void CP_PlaceRoadStop(TileIndex tile, uint8 direction, uint8 roadtype, bool truck_stop, bool drive_through);
+	void CP_PlaceRail_Tunnel(TileIndex tile, uint32 railtype);
+	void CP_PlaceRoad_Tunnel(TileIndex tile, uint8 roadtype);
+	void CP_Build_Bridge    (TileIndex start, TileIndex end, uint8 bridgetype, uint8 transport_type, uint8 rail_road_type);
+	void CP_PlaceRail_Depot (TileIndex tile, uint8 railtype, uint8 direction);
+	void CP_PlaceRoad_Depot (TileIndex tile, uint8 direction_type);
+	void CP_PlaceWaypoint   (TileIndex tile, uint8 waypoint_type);
+	void CP_ClearTile       (TileIndex start_tile, TileIndex end_tile);
+		
+	uint8 MirrorSignalDirection(uint8 direction);
+	DisallowedRoadDirections MirrorOneWayRoadDirection(DisallowedRoadDirections drd);
+	void SwapSignalInfo(uint index);
+	void PasteSignals(uint index, TileIndex tile);
+	void PasteLandscape(TileIndex tile);
+
+	void TerrainNeededAroundTile(TileIndex tindex, TileIndex bindex);
+	int8 ClampToRight(TileIndex index, int8 baseh, int8 h_tile);
+	int8 ClampToUp(TileIndex index, int8 baseh, int8 h_tile, int32 size_x);
+
+	FORCEINLINE void SetWidth(uint32 width)   { m_width  = width;  };
+	FORCEINLINE void SetHeight(uint32 height) { m_height = height; }; 
+};
+
+extern CopyPaste _copy_paste;
+
+#endif /* COPY_PASTE_H */
+
diff --git a/src/copy_paste_gui.cpp b/src/copy_paste_gui.cpp
new file mode 100644
--- /dev/null
+++ b/src/copy_paste_gui.cpp
@@ -0,0 +1,314 @@
+/* $Id: copy_paste_gui.cpp 4998 2006-05-28 07:45:14Z Frostregen $ */
+
+#include "stdafx.h"
+#include "openttd.h"
+#include "gui.h"
+#include "window_gui.h"
+#include "viewport_type.h"
+#include "viewport_func.h"
+#include "gfx_func.h"
+#include "strings_type.h"
+#include "clear_func.h"
+#include "window_type.h"
+#include "window_func.h"
+#include "sound_type.h"
+#include "sound_func.h"
+#include "tilehighlight_type.h"
+#include "tilehighlight_func.h"
+#include "company_func.h"
+#include "tile_type.h"
+#include "rail_type.h"
+#include "rail_gui.h"
+#include "sprite.h"
+#include "fios.h"
+#include "copy_paste.h"
+#include "table/sprites.h"
+#include "table/strings.h"
+
+
+/** Current railtype. Used for autoconversion */
+static RailType _last_railtype = RAILTYPE_RAIL;
+
+/* **** GUI Code for Copy&Paste **** */
+
+/** Enum referring to the widgets of the copy paste window */
+enum CopyPasteWidgets {
+	CPW_CLOSEBOX = 0,
+	CPW_CAPTION,
+	CPW_STICKYBOX,
+	CPW_SPACER_1,
+	CPW_SPACER_2,
+	CPW_SPACER_3,
+	CPW_COPY,
+	CPW_PASTE,
+	CPW_LOAD,
+	CPW_SAVE,
+	CPW_ROTATE_LEFT,
+	CPW_ROTATE_RIGHT,
+	CPW_MIRROR_HORIZONTAL,
+	CPW_MIRROR_VERTICAL,
+	CPW_TERRAIN,
+	CPW_DYNAMITE,
+	CPW_RAIL,
+	CPW_ROAD,
+	CPW_REVERSE_SIGNALS,
+	CPW_CONVERT_RAILTYPE,
+	CPW_ONLY_OWN,
+
+	CPW_FIRST_CLICKABLE = CPW_COPY,
+	CPW_LAST_CLICKABLE = CPW_ONLY_OWN,
+};
+
+struct CopyPasteWindow : Window {
+int last_user_action; ///< Last started user action.
+public:
+	CopyPasteWindow(const WindowDesc *desc, WindowNumber window_number) : Window()
+	{
+		this->InitNested(desc, window_number);
+		this->last_user_action = WIDGET_LIST_END;
+
+		/* Set the button states according to variable content */
+		if (_copy_paste.m_clear_before_build) this->LowerWidget(CPW_DYNAMITE);
+		if (_copy_paste.m_toggle_signal_direction) this->LowerWidget(CPW_REVERSE_SIGNALS);
+		if (_copy_paste.m_convert_rail)	  this->LowerWidget(CPW_CONVERT_RAILTYPE);
+		if (_copy_paste.m_copy_with_rail) this->LowerWidget(CPW_RAIL);
+		if (_copy_paste.m_copy_with_road) this->LowerWidget(CPW_ROAD);
+		if (_copy_paste.m_copy_with_other)this->LowerWidget(CPW_ONLY_OWN);
+	}
+
+	virtual void OnPaint()
+	{
+		SetWidgetsDisabledState(!_copy_paste.IsSomethingCopied(), CPW_PASTE, CPW_SAVE,
+				CPW_ROTATE_LEFT, CPW_ROTATE_RIGHT, CPW_MIRROR_HORIZONTAL, CPW_MIRROR_VERTICAL,
+				WIDGET_LIST_END);
+		/* Set image for tri-state button */
+		this->GetWidget<NWidgetCore>(CPW_TERRAIN)->widget_data = SPR_IMG_MINUS_TERRAIN + _copy_paste.m_paste_vacant_terrain;
+
+		this->DrawWidgets();
+
+		/* Draw CylinderGuy in CompanyColor, if unclicked */
+		if (!this->IsWidgetLowered(CPW_ONLY_OWN))
+			DrawSprite(SPR_IMG_ONLY_OWN, COMPANY_SPRITE_COLOUR(_current_company), this->GetWidget<NWidgetCore>(CPW_ONLY_OWN)->pos_x + 1, this->GetWidget<NWidgetCore>(CPW_ONLY_OWN)->pos_y + 1);
+	}
+
+	virtual void OnClick(Point pt, int widget, int click_count)
+	{
+		SetWidgetsDisabledState(!_copy_paste.IsSomethingCopied(), CPW_PASTE, CPW_SAVE,
+				CPW_ROTATE_LEFT, CPW_ROTATE_RIGHT, CPW_MIRROR_HORIZONTAL, CPW_MIRROR_VERTICAL,
+				WIDGET_LIST_END);
+		if (this->IsWidgetDisabled(widget)) return;
+		if ((widget >= CPW_FIRST_CLICKABLE) && (widget <= CPW_LAST_CLICKABLE)) {
+			if (widget != CPW_COPY && widget != CPW_PASTE && 
+				widget != CPW_DYNAMITE && widget != CPW_REVERSE_SIGNALS && 
+				widget != CPW_RAIL && widget !=  CPW_CONVERT_RAILTYPE && 
+				widget != CPW_ROAD && widget != CPW_ONLY_OWN) {
+				this->HandleButtonClick(widget);
+			}
+			SndPlayFx(SND_15_BEEP);
+			switch (widget) {
+				case CPW_COPY:
+					HandlePlacePushButton(this, CPW_COPY, SPR_CURSOR_COPY, HT_RECT);
+					this->last_user_action = widget;
+					break;
+
+				case CPW_PASTE:
+					HandlePlacePushButton(this, CPW_PASTE, SPR_CURSOR_PASTE, HT_PREVIEW);
+					this->last_user_action = widget;
+					break;
+
+				case CPW_LOAD:
+					_copy_paste.m_toggle_signal_direction = false;
+					/* fallthrough */
+
+				case CPW_SAVE:
+					ShowSaveLoadDialog(widget == CPW_SAVE ? SLD_SAVE_TEMPLATE : SLD_LOAD_TEMPLATE);
+					break;
+
+				case CPW_ROTATE_LEFT:
+				case CPW_ROTATE_RIGHT:
+					if (widget == CPW_ROTATE_LEFT)  _copy_paste.RotateSelectionCCW();
+					if (widget == CPW_ROTATE_RIGHT) _copy_paste.RotateSelectionCW();
+					break;
+
+				case CPW_MIRROR_HORIZONTAL:
+				case CPW_MIRROR_VERTICAL:
+					if (widget == CPW_MIRROR_HORIZONTAL) _copy_paste.MirrorSelectionHorizontal();
+					if (widget == CPW_MIRROR_VERTICAL)   _copy_paste.MirrorSelectionVertical();
+					
+					/* Toggle SignalDir */
+					this->OnClick(Point(), CPW_REVERSE_SIGNALS, 1);
+					break;
+
+				case CPW_TERRAIN:
+					_copy_paste.m_paste_vacant_terrain++;
+					if (_copy_paste.m_paste_vacant_terrain > 2) _copy_paste.m_paste_vacant_terrain = 0;
+					break;
+
+				case CPW_DYNAMITE: case CPW_REVERSE_SIGNALS:
+				case CPW_RAIL: case CPW_CONVERT_RAILTYPE:
+				case CPW_ROAD: case CPW_ONLY_OWN: {
+					this->SetDirty();
+					this->ToggleWidgetLoweredState(widget);
+					bool state = IsWidgetLowered(widget);
+					switch (widget) {
+						case CPW_DYNAMITE:	       _copy_paste.m_clear_before_build = state; break;
+						case CPW_RAIL:             _copy_paste.m_copy_with_rail = state; break;
+						case CPW_ROAD:             _copy_paste.m_copy_with_road = state; break;
+						case CPW_REVERSE_SIGNALS:  _copy_paste.m_toggle_signal_direction = state; break;
+						case CPW_CONVERT_RAILTYPE: _copy_paste.m_convert_rail = state; break;
+						case CPW_ONLY_OWN:         _copy_paste.m_copy_with_other = state; break;
+						default: NOT_REACHED();
+					}
+				} break;
+				default: break;
+			}
+
+			/* Set Selection size to Copy size */
+			if (this->IsWidgetLowered(CPW_PASTE)) {
+				if (_copy_paste.GetWidth() > 0)
+					SetTileSelectSize(_copy_paste.GetWidth() - 1, _copy_paste.GetHeight() - 1);
+			} else {
+				SetTileSelectSize(1, 1);
+			}
+		}
+	}
+
+	virtual void OnPlaceObject(Point pt, TileIndex tile)
+	{
+		switch (this->last_user_action) { 
+			case CPW_COPY:
+				VpStartPlaceSizing(tile, VPM_X_AND_Y_LIMITED, DDSP_COPY_AREA);
+				VpSetPlaceSizingLimit(255);
+				break;
+
+			case CPW_PASTE:
+				_copy_paste.PasteArea(tile);
+				break;
+		}
+	}
+
+	virtual void OnPlaceDrag(ViewportPlaceMethod select_method, ViewportDragDropSelectionProcess select_proc, Point pt)
+	{
+		VpSelectTilesWithMethod(pt.x, pt.y, select_method);
+	}
+
+	virtual void OnPlaceMouseUp(ViewportPlaceMethod select_method, ViewportDragDropSelectionProcess select_proc, Point pt, TileIndex start_tile, TileIndex end_tile)
+	{
+		if (pt.x != -1) {
+			switch (select_proc) {
+				case DDSP_COPY_AREA:
+					_copy_paste.CopyArea(end_tile, start_tile);
+					/* Reset SignalDir */
+					if (_copy_paste.m_toggle_signal_direction) this->OnClick(Point(), CPW_REVERSE_SIGNALS, 1);
+					this->SetDirty();
+					break;
+				default:
+					break;
+			}
+		}
+	}
+
+	virtual void OnPlaceObjectAbort()
+	{
+		/* UnclickWindowButtons "copy" and "paste" */
+		this->RaiseWidget(CPW_COPY);
+		this->RaiseWidget(CPW_PASTE);
+
+		this->SetDirty();
+	}
+
+	virtual void OnTimeout()
+	{
+		this->RaiseWidget(CPW_LOAD);
+		this->RaiseWidget(CPW_SAVE);
+		this->RaiseWidget(CPW_ROTATE_LEFT);
+		this->RaiseWidget(CPW_ROTATE_RIGHT);
+		this->RaiseWidget(CPW_MIRROR_HORIZONTAL);
+		this->RaiseWidget(CPW_MIRROR_VERTICAL);
+		this->RaiseWidget(CPW_TERRAIN);
+		this->SetDirty();
+	}
+
+	virtual void OnTick()
+	{
+		/* If railtype has changed, we need to update our GUI */
+		if (_last_railtype != _cur_railtype) {
+			const RailtypeInfo *rti = GetRailTypeInfo(_cur_railtype);
+			_last_railtype = _cur_railtype;
+			this->GetWidget<NWidgetCore>(CPW_CONVERT_RAILTYPE)->widget_data = rti->gui_sprites.convert_rail;
+			this->SetDirty();
+		}
+	}
+};
+
+static const NWidgetPart _nested_copy_paste_widgets[] = {
+	NWidget(NWID_HORIZONTAL),
+		NWidget(WWT_CLOSEBOX, COLOUR_DARK_GREEN),
+		NWidget(WWT_CAPTION, COLOUR_DARK_GREEN), SetDataTip(STR_COPY_PASTE_TOOLBAR, STR_TOOLTIP_WINDOW_TITLE_DRAG_THIS),
+		NWidget(WWT_STICKYBOX, COLOUR_DARK_GREEN),
+	EndContainer(),
+	NWidget(NWID_HORIZONTAL),
+		NWidget(WWT_IMGBTN, COLOUR_DARK_GREEN, CPW_COPY), SetMinimalSize(22,22),
+								SetFill(0, 1), SetDataTip(SPR_IMG_COPY,              STR_COPY_PASTE_COPY_TOOLTIP),
+		NWidget(WWT_IMGBTN, COLOUR_DARK_GREEN, CPW_PASTE), SetMinimalSize(22,22),
+								SetFill(0, 1), SetDataTip(SPR_IMG_PASTE,             STR_COPY_PASTE_PASTE_TOOLTIP),
+
+		NWidget(WWT_PANEL, COLOUR_DARK_GREEN), SetMinimalSize(4, 22), EndContainer(),
+
+		NWidget(WWT_IMGBTN, COLOUR_DARK_GREEN, CPW_LOAD), SetMinimalSize(22,22),
+								SetFill(0, 1), SetDataTip(SPR_IMG_LOAD,              STR_COPY_PASTE_LOAD_TOOLTIP),
+		NWidget(WWT_IMGBTN, COLOUR_DARK_GREEN, CPW_SAVE), SetMinimalSize(22,22),
+								SetFill(0, 1), SetDataTip(SPR_IMG_SAVE,              STR_COPY_PASTE_SAVE_TOOLTIP),
+
+		NWidget(WWT_PANEL, COLOUR_DARK_GREEN), SetMinimalSize(4, 22), EndContainer(),
+
+		NWidget(WWT_IMGBTN, COLOUR_DARK_GREEN, CPW_ROTATE_LEFT), SetMinimalSize(22,22),
+								SetFill(0, 1), SetDataTip(SPR_IMG_ROTATE_LEFT,       STR_COPY_PASTE_ROTATE_LEFT_TOOLTIP),
+		NWidget(WWT_IMGBTN, COLOUR_DARK_GREEN, CPW_ROTATE_RIGHT), SetMinimalSize(22,22),
+								SetFill(0, 1), SetDataTip(SPR_IMG_ROTATE_RIGHT,      STR_COPY_PASTE_ROTATE_RIGHT_TOOLTIP),
+		NWidget(WWT_IMGBTN, COLOUR_DARK_GREEN, CPW_MIRROR_HORIZONTAL), SetMinimalSize(22,22),
+								SetFill(0, 1), SetDataTip(SPR_IMG_MIRROR_HORIZONTAL, STR_COPY_PASTE_MIRROR_HORIZONTAL_TOOLTIP),
+		NWidget(WWT_IMGBTN, COLOUR_DARK_GREEN, CPW_MIRROR_VERTICAL), SetMinimalSize(22,22),
+								SetFill(0, 1), SetDataTip(SPR_IMG_MIRROR_VERTICAL,   STR_COPY_PASTE_MIRROR_VERTICAL_TOOLTIP),
+
+		NWidget(WWT_PANEL, COLOUR_DARK_GREEN), SetMinimalSize(4, 22), EndContainer(),
+
+		NWidget(WWT_IMGBTN, COLOUR_DARK_GREEN, CPW_TERRAIN), SetMinimalSize(22,22),
+								SetFill(0, 1), SetDataTip(SPR_IMG_MINUS_TERRAIN,     STR_COPY_PASTE_VACANT_TERRAIN_TOOLTIP),
+		NWidget(WWT_IMGBTN_2, COLOUR_DARK_GREEN, CPW_DYNAMITE), SetMinimalSize(22,22),
+								SetFill(0, 1), SetDataTip(SPR_IMG_MINUS_DYNAMITE,    STR_COPY_PASTE_BULLDOZE_BEFORE_BUILD_TOOLTIP),
+		NWidget(WWT_IMGBTN_2, COLOUR_DARK_GREEN, CPW_RAIL), SetMinimalSize(22,22),
+								SetFill(0, 1), SetDataTip(SPR_IMG_NO_RAIL,           STR_COPY_PASTE_WITHOUT_RAIL_TOOLTIP),
+		NWidget(WWT_IMGBTN_2, COLOUR_DARK_GREEN, CPW_ROAD), SetMinimalSize(22,22),
+								SetFill(0, 1), SetDataTip(SPR_IMG_NO_ROAD,           STR_COPY_PASTE_WITHOUT_ROAD_TOOLTIP),
+		NWidget(WWT_IMGBTN_2, COLOUR_DARK_GREEN, CPW_REVERSE_SIGNALS), SetMinimalSize(22,22),
+								SetFill(0, 1), SetDataTip(SPR_IMG_MINUS_SIGNAL,      STR_COPY_PASTE_TOGGLE_SIGNAL_DIRECTION_TOOLTIP),
+		NWidget(WWT_IMGBTN, COLOUR_DARK_GREEN, CPW_CONVERT_RAILTYPE), SetMinimalSize(22,22),
+								SetFill(0, 1), SetDataTip(SPR_IMG_CONVERT_RAIL,      STR_COPY_PASTE_CONVERT_RAIL_TOOLTIP),
+		NWidget(WWT_IMGBTN_2, COLOUR_DARK_GREEN, CPW_ONLY_OWN), SetMinimalSize(22,22),
+								SetFill(0, 1), SetDataTip(SPR_IMG_ONLY_OWN,          STR_COPY_PASTE_ONLY_OWN_TOOLTIP),
+	EndContainer(),
+};
+
+static const WindowDesc _copy_paste_desc(
+	WDP_ALIGN_TOOLBAR, 0, 0,
+	WC_COPY_PASTE, WC_SCEN_LAND_GEN,
+	WDF_CONSTRUCTION,
+	_nested_copy_paste_widgets, lengthof(_nested_copy_paste_widgets)
+);
+
+void ShowCopyPasteToolbarGui() // When clicking the button in the terrain generation gui
+{
+	AllocateWindowDescFront<CopyPasteWindow>(&_copy_paste_desc, 0);
+}
+
+void ShowCopyPasteToolbar(int button) // When using a shortcut
+{
+	Window *w;
+	/* don't recreate the window if we're clicking on a button and the window exists. */
+	if (button < CPW_FIRST_CLICKABLE || !(w = FindWindowById(WC_COPY_PASTE, 0))) {
+		DeleteWindowByClass(WC_COPY_PASTE);
+		w = new CopyPasteWindow(&_copy_paste_desc, 0);
+	}
+	if (w != NULL) w->OnClick(Point(), button, 1);
+}
diff --git a/src/core/endian_type.hpp b/src/core/endian_type.hpp
--- a/src/core/endian_type.hpp
+++ b/src/core/endian_type.hpp
@@ -30,7 +30,7 @@
 	#define TTD_ENDIAN TTD_LITTLE_ENDIAN
 #elif !defined(TESTING)
 	/* Else include endian[target/host].h, which has the endian-type, autodetected by the Makefile */
-	#if defined(STRGEN) || defined(SETTINGSGEN)
+	#if defined(STRGEN)
 		#include "endian_host.h"
 	#else
 		#include "endian_target.h"
diff --git a/src/core/math_func.cpp b/src/core/math_func.cpp
--- a/src/core/math_func.cpp
+++ b/src/core/math_func.cpp
@@ -46,3 +46,24 @@
 	return a;
 
 }
+
+/**
+ * Deterministic approximate division.
+ * Cancels out division errors stemming from the integer nature of the division over multiple runs.
+ * @param a Dividend.
+ * @param b Divisor.
+ * @return a/b or (a/b)+1.
+ */
+int DivideApprox(int a, int b)
+{
+	int random_like = ((a + b) * (a - b)) % b;
+
+	int remainder = a % b;
+
+	int ret = a / b;
+	if (abs(random_like) < abs(remainder)) {
+		ret += ((a < 0) ^ (b < 0)) ? -1 : 1;
+	}
+
+	return ret;
+}
diff --git a/src/core/math_func.hpp b/src/core/math_func.hpp
--- a/src/core/math_func.hpp
+++ b/src/core/math_func.hpp
@@ -317,6 +317,7 @@
 
 int LeastCommonMultiple(int a, int b);
 int GreatestCommonDivisor(int a, int b);
+int DivideApprox(int a, int b);
 
 /**
  * Computes ceil(a / b) for non-negative a and b.
diff --git a/src/core/multimap.hpp b/src/core/multimap.hpp
new file mode 100644
--- /dev/null
+++ b/src/core/multimap.hpp
@@ -0,0 +1,249 @@
+/* $Id$ */
+
+/*
+ * This file is part of OpenTTD.
+ * OpenTTD is free software; you can redistribute it and/or modify it under the terms of the GNU General Public License as published by the Free Software Foundation, version 2.
+ * OpenTTD is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
+ * See the GNU General Public License for more details. You should have received a copy of the GNU General Public License along with OpenTTD. If not, see <http://www.gnu.org/licenses/>.
+ */
+
+/** @file multimap.hpp Multimap with deterministic ordering of items with equal keys. */
+
+#ifndef MULTIMAP_HPP_
+#define MULTIMAP_HPP_
+
+#include <map>
+#include <list>
+
+template<typename KEY, typename VALUE, typename COMPARE>
+class MultiMap;
+
+template<class MAP_ITER, class LIST_ITER, class KEY, class VALUE, class COMPARE>
+class MultiMapIterator {
+protected:
+	friend class MultiMap<KEY, VALUE, COMPARE>;
+	typedef MultiMapIterator<MAP_ITER, LIST_ITER, KEY, VALUE, COMPARE> Self;
+	LIST_ITER list_iter;
+	MAP_ITER map_iter;
+	bool list_valid;
+
+public:
+	MultiMapIterator() : list_valid(false) {}
+	template<class NONCONST>
+	MultiMapIterator(NONCONST mi) : map_iter(mi), list_valid(false) {}
+	MultiMapIterator(MAP_ITER mi, LIST_ITER li) : list_iter(li), map_iter(mi)
+	{
+		list_valid = (list_iter != map_iter->second.begin());
+	}
+
+	template<class NONCONST>
+	Self &operator=(NONCONST mi)
+	{
+		map_iter = mi;
+		list_valid = false;
+	}
+
+	VALUE &operator*() const
+	{
+		assert(!map_iter->second.empty());
+		if (list_valid) {
+			return list_iter.operator*();
+		} else {
+			return map_iter->second.begin().operator*();
+		}
+	}
+
+	VALUE *operator->() const
+	{
+		assert(!map_iter->second.empty());
+		if (list_valid) {
+			return list_iter.operator->();
+		} else {
+			return map_iter->second.begin().operator->();
+		}
+	}
+
+	FORCEINLINE const MAP_ITER &GetMapIter() const {return map_iter;}
+	FORCEINLINE const LIST_ITER &GetListIter() const {return list_iter;}
+	FORCEINLINE bool ListValid() const {return list_valid;}
+
+	const KEY &GetKey() const {return map_iter->first;}
+
+	Self &operator++()
+	{
+		assert(!map_iter->second.empty());
+		if (list_valid) {
+			if(++list_iter == map_iter->second.end()) {
+				++map_iter;
+				list_valid = false;
+			}
+		} else {
+			list_iter = ++(map_iter->second.begin());
+			if (list_iter == map_iter->second.end()) {
+				++map_iter;
+			} else {
+				list_valid = true;
+			}
+		}
+		return *this;
+	}
+
+	Self operator++(int)
+	{
+		Self tmp = *this;
+		this->operator++();
+		return tmp;
+	}
+
+	Self &operator--()
+	{
+		assert(!map_iter->second.empty());
+		if (!list_valid) {
+			--map_iter;
+			list_iter = map_iter->second.end();
+			assert(!map_iter->second.empty());
+		}
+
+		if(--list_iter == map_iter->second.begin()) {
+			list_valid = false;
+		} else {
+			list_valid = true;
+		}
+
+		return *this;
+	}
+
+	Self operator--(int)
+	{
+		Self tmp = *this;
+		this->operator--();
+		return tmp;
+	}
+};
+
+/* generic comparison functions for const/non-const multimap iterators and map iterators */
+
+template<class MAP_ITER1, class LIST_ITER1, class MAP_ITER2, class LIST_ITER2, class KEY, class VALUE1, class VALUE2, class COMPARE>
+bool operator==(const MultiMapIterator<MAP_ITER1, LIST_ITER1, KEY, VALUE1, COMPARE> &iter1, const MultiMapIterator<MAP_ITER2, LIST_ITER2, KEY, VALUE2, COMPARE> &iter2)
+{
+	if (iter1.ListValid()) {
+		if (!iter2.ListValid()) {
+			return false;
+		} else if (iter1.GetListIter() != iter2.GetListIter()) {
+			return false;
+		}
+	} else if (iter2.ListValid()) {
+		return false;
+	}
+	return (iter1.GetMapIter() == iter2.GetMapIter());
+}
+
+template<class MAP_ITER1, class LIST_ITER1, class MAP_ITER2, class LIST_ITER2, class KEY, class VALUE1, class VALUE2, class COMPARE>
+bool operator!=(const MultiMapIterator<MAP_ITER1, LIST_ITER1, KEY, VALUE1, COMPARE> &iter1, const MultiMapIterator<MAP_ITER2, LIST_ITER2, KEY, VALUE2, COMPARE> &iter2)
+{
+	return !(iter1 == iter2);
+}
+
+template<class MAP_ITER1, class LIST_ITER1, class MAP_ITER2, class KEY, class VALUE, class COMPARE >
+bool operator==(const MultiMapIterator<MAP_ITER1, LIST_ITER1, KEY, VALUE, COMPARE> &iter1, const MAP_ITER2 &iter2)
+{
+	return !iter1.ListValid() && iter1.GetMapIter() == iter2;
+}
+
+template<class MAP_ITER1, class LIST_ITER1, class MAP_ITER2, class KEY, class VALUE, class COMPARE >
+bool operator!=(const MultiMapIterator<MAP_ITER1, LIST_ITER1, KEY, VALUE, COMPARE> &iter1, const MAP_ITER2 &iter2)
+{
+	return iter1.ListValid() || iter1.GetMapIter() != iter2;
+}
+
+template<class MAP_ITER1, class LIST_ITER1, class MAP_ITER2, class KEY, class VALUE, class COMPARE >
+bool operator==(const MAP_ITER2 &iter2, const MultiMapIterator<MAP_ITER1, LIST_ITER1, KEY, VALUE, COMPARE> &iter1)
+{
+	return !iter1.ListValid() && iter1.GetMapIter() == iter2;
+}
+
+template<class MAP_ITER1, class LIST_ITER1, class MAP_ITER2, class KEY, class VALUE, class COMPARE >
+bool operator!=(const MAP_ITER2 &iter2, const MultiMapIterator<MAP_ITER1, LIST_ITER1, KEY, VALUE, COMPARE> &iter1)
+{
+	return iter1.ListValid() || iter1.GetMapIter() != iter2;
+}
+
+
+/**
+ * hand-rolled multimap as map of lists. behaves mostly like a list, but is sorted
+ * by KEY.
+ */
+template<typename KEY, typename VALUE, typename COMPARE = std::less<KEY> >
+class MultiMap : public std::map<KEY, std::list<VALUE>, COMPARE > {
+public:
+	typedef typename std::list<VALUE> List;
+	typedef typename List::iterator ListIterator;
+	typedef typename List::const_iterator ConstListIterator;
+
+	typedef typename std::map<KEY, List, COMPARE > Map;
+	typedef typename Map::iterator MapIterator;
+	typedef typename Map::const_iterator ConstMapIterator;
+
+	typedef MultiMapIterator<MapIterator, ListIterator, KEY, VALUE, COMPARE> iterator;
+	typedef MultiMapIterator<ConstMapIterator, ConstListIterator, KEY, const VALUE, COMPARE> const_iterator;
+
+	void erase(iterator it)
+	{
+		List &list = it.map_iter->second;
+		assert(!list.empty());
+		if (it.ListValid()) {
+			list.erase(it.list_iter);
+		} else {
+			list.erase(list.begin());
+		}
+
+		if (list.empty()) {
+			Map::erase(it.map_iter);
+		}
+	}
+
+	void Insert(const KEY &key, const VALUE &val)
+	{
+		List &list = (*this)[key];
+		list.push_back(val);
+		assert(!list.empty());
+	}
+
+	size_t size() const
+	{
+		size_t ret = 0;
+		for(ConstMapIterator it = Map::begin(); it != Map::end(); ++it) {
+			ret += it->second.size();
+		}
+		return ret;
+	}
+
+	size_t MapSize() const
+	{
+		return Map::size();
+	}
+
+	std::pair<iterator, iterator> equal_range(const KEY &key)
+	{
+		MapIterator begin(lower_bound(key));
+		if (begin != Map::end() && begin->first == key) {
+			MapIterator end = begin;
+			return std::make_pair(begin, ++end);
+		} else {
+			return std::make_pair(begin, begin);
+		}
+	}
+
+	std::pair<const_iterator, const_iterator> equal_range(const KEY &key) const
+	{
+		ConstMapIterator begin(lower_bound(key));
+		if (begin != Map::end() && begin->first == key) {
+			ConstMapIterator end = begin;
+			return std::make_pair(begin, ++end);
+		} else {
+			return std::make_pair(begin, begin);
+		}
+	}
+};
+
+#endif /* MULTIMAP_HPP_ */
diff --git a/src/core/overflowsafe_type.hpp b/src/core/overflowsafe_type.hpp
--- a/src/core/overflowsafe_type.hpp
+++ b/src/core/overflowsafe_type.hpp
@@ -96,6 +96,7 @@
 	FORCEINLINE OverflowSafeInt  operator /  (const OverflowSafeInt& divisor) const { OverflowSafeInt result = *this; result /= divisor.m_value; return result; }
 	FORCEINLINE OverflowSafeInt  operator /  (const int              divisor) const { OverflowSafeInt result = *this; result /= divisor; return result; }
 	FORCEINLINE OverflowSafeInt  operator /  (const uint             divisor) const { OverflowSafeInt result = *this; result /= (int)divisor; return result; }
+	FORCEINLINE OverflowSafeInt  operator /  (const uint8            divisor) const { OverflowSafeInt result = *this; result /= (int16)divisor; return result; }
 
 	/* Operators for modulo */
 	FORCEINLINE OverflowSafeInt& operator %= (const int  divisor)       { this->m_value %= divisor; return *this; }
diff --git a/src/date.cpp b/src/date.cpp
--- a/src/date.cpp
+++ b/src/date.cpp
@@ -25,6 +25,7 @@
 Date      _date;       ///< Current date in days (day counter)
 DateFract _date_fract; ///< Fractional part of the day.
 uint16 _tick_counter;  ///< Ever incrementing (and sometimes wrapping) tick counter for setting off various events
+uint8     _date_daylength_factor;	///< Setting for DAY_LENGTH
 
 /**
  * Set the date.
@@ -175,8 +176,10 @@
 
 
 /** Available settings for autosave intervals. */
-static const Month _autosave_months[] = {
+static const int _autosave_intervals[] = {
 	 0, ///< never
+	 1, ///< every day
+	 7, ///< every week
 	 1, ///< every month
 	 3, ///< every 3 months
 	 6, ///< every 6 months
@@ -226,7 +229,7 @@
  */
 static void OnNewMonth()
 {
-	if (_settings_client.gui.autosave != 0 && (_cur_month % _autosave_months[_settings_client.gui.autosave]) == 0) {
+	if (_settings_client.gui.autosave >= 3 && (_cur_month % _autosave_intervals[_settings_client.gui.autosave]) == 0) {
 		_do_autosave = true;
 		SetWindowDirty(WC_STATUS_BAR, 0);
 	}
@@ -248,6 +251,12 @@
  */
 static void OnNewDay()
 {
+	// XXX: use day-of-month?
+	if (_settings_client.gui.autosave != 0 && _settings_client.gui.autosave <= 2 && (_date % _autosave_intervals[_settings_client.gui.autosave]) == 0) {
+		_do_autosave = true;
+		SetWindowDirty(WC_STATUS_BAR, 0);
+	}
+
 #ifdef ENABLE_NETWORK
 	if (_network_server) NetworkServerDailyLoop();
 #endif /* ENABLE_NETWORK */
diff --git a/src/date_func.h b/src/date_func.h
--- a/src/date_func.h
+++ b/src/date_func.h
@@ -24,6 +24,8 @@
 void ConvertDateToYMD(Date date, YearMonthDay *ymd);
 Date ConvertYMDToDate(Year year, Month month, Day day);
 
+#define YMD_TO_DATE(ymd) (ConvertYMDToDate(ymd.year, ymd.month, ymd.day))
+
 /**
  * Checks whether the given year is a leap year or not.
  * @param yr The year to check.
